

//+------------------------------------------------------------------+
//|                                                       MA_RSI.mq4 |
//|                                                  Alexei Parvatkin|
//|                                                  alexpar@list.ru |
//+------------------------------------------------------------------+
#property copyright "2009. Alexei Parvatkin. Togliatti"
#property link      "e-mail: alexpar@list.ru"
 
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 Magenta
#property indicator_color2 DodgerBlue
#property indicator_width1 2
#property indicator_width2 2
#property indicator_color3 Brown
#property indicator_color4 LightSeaGreen
#property indicator_width3 2
#property indicator_width4 2
#property indicator_level1 55
#property indicator_level2 45
#property indicator_level3 50
#property indicator_levelcolor Silver
#property indicator_levelstyle 2
#property indicator_maximum 90
#property indicator_minimum 10
//---- input parameters
 
extern int RSI_Period= 10;
extern int RSI_Mode=0;
extern int  MA_Period=9;
extern int  MA_Mode  =0;
extern int Limit=0;//5440;
extern int MF        = 240;
extern int RSI_Period_MF= 10;
extern int RSI_Mode_MF=0;
extern int  MA_Period_MF=9;
extern int  MA_Mode_MF  =0;

double RSI[];
double MA[];
double RSIMF[];
double MAMF[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexStyle(1,DRAW_LINE,0,2);
   SetIndexStyle(2,DRAW_LINE,0,2);
   SetIndexStyle(3,DRAW_LINE,0,2);


   SetIndexDrawBegin(0,RSI_Period+MA_Period);
   SetIndexDrawBegin(1,RSI_Period+MA_Period);
   SetIndexDrawBegin(2,RSI_Period+MA_Period);
   SetIndexDrawBegin(3,RSI_Period+MA_Period);

   SetIndexBuffer(0,RSI);
   SetIndexBuffer(1,MA);
   SetIndexBuffer(2,RSIMF);
   SetIndexBuffer(3,MAMF);

   IndicatorShortName("RSI_MA_MF("+RSI_Period+","+MA_Period+")");
   SetIndexLabel(0,"RSI");
   SetIndexLabel(1,"MA");
   SetIndexLabel(2,"RSIMF");
   SetIndexLabel(3,"MAMF");

   return(0); }
 
//+------------------------------------------------------------------+
int start() {
   int limit,limit1;
   int counted_bars=IndicatorCounted();
   int i,C_time, Bar_Shift;
 
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   if (limit>Limit && Limit>0) limit = Limit;
   for (i = limit;i>=0;i--) RSI[i] = iRSI(Symbol(),Period(),RSI_Period,RSI_Mode,i);
   for (i = limit;i>=0;i--) MA[i] = iMAOnArray(RSI,0,MA_Period,0,MA_Mode,i);
//   for (i = limit;i>=0;i--)
   limit1 = 2*MF/Period();
   if (limit1 < limit) limit1=limit;
   for (i = limit1;i>=0;i--)
   {
      C_time=Time[i];
      Bar_Shift=iBarShift(NULL,MF,C_time,false);
      RSIMF[i] = iCustom(Symbol(),MF,"RSI_MA",RSI_Period_MF,RSI_Mode_MF,MA_Period_MF,MA_Mode_MF,0,Bar_Shift);
      MAMF[i] = iCustom(Symbol(),MF,"RSI_MA",RSI_Period_MF,RSI_Mode_MF,MA_Period_MF,MA_Mode_MF,1,Bar_Shift);
   }
   
   return(0); 
}// int start()

